(in-package json-test)

(defun generate-random-json-string (stream length-limit)
  (princ #\" stream)
  (let ((a (char-code #\A)))
    (dotimes (i (random length-limit))
      (princ (code-char (+ a (random 26))) stream)))
  (princ #\" stream))

(defun generate-random-json-integer (stream)
  (princ (round (expt (* (random 100) (random 10000))
                      (/ (1+ (random 1.85)))))
         stream))

(defun generate-random-json-real (stream)
  (princ (expt (* (random 104.293) (random 9558.00017))
               (/ (1+ (random 1.85))))
         stream))

(defun generate-random-json-boolean (stream)
  (princ (aref #("true" "false" "null") (random 3))
         stream))

(defun generate-random-json (stream limit)
  (loop with stack = (list (princ #\{ stream))
     and depth = 1
     and count = 2
     and first-element = t
     while (> depth 0)
     for op = (random (ceiling (/ limit (log (incf count)))))
     if (> op depth)
       do (when (not first-element)
            (princ #\, stream)
            (setq first-element t))
          (when (char= (car stack) #\{)
            (generate-random-json-string stream 16)
            (princ #\: stream))
          (push (princ (if (evenp op) #\{ #\[) stream) stack)
          (incf depth)
     else
       do (let ((subop (random 8)))
            (when (< subop 4)
              (unless first-element (princ #\, stream))
              (when (char= (car stack) #\{)
                (generate-random-json-string stream 16)
                (princ #\: stream)))
            (setq first-element nil)
            (case subop
              (0 (generate-random-json-integer stream))
              (1 (generate-random-json-real stream))
              (2 (generate-random-json-boolean stream))
              (3 (generate-random-json-string stream 32))
              (t (princ (case (pop stack) (#\{ #\}) (#\[ #\])) stream)
                 (decf depth))))))

      
